%************** MAIN CODE **************
% CE 525 Fall 2018
% HW1_Prob1_MATLAB
% Units: kN and mm

clc     %Clear the window
clear   %Clear the memory

% This general format works well for most engineering problems
format short g

% Define the number of element dofs (always 2 for the uniaxial element)
NEdof=2;

% Define the number of structural dofs
NSdof=2;

% Initialize [S]
S=zeros(NSdof,NSdof);
Pf=zeros(NSdof,1);
E=20;
P=[-24;0] % The semicolon is a separator between rows in the vector

% Define the code numbers
CodeNum=[
3 1
3 1
1 2
2 4] % Here we write out each row explicitly

% Define geometry and loading for each member create the member stiffness
% and then assemble [S]. Note that no units are shown, you just need to be
% be consistent.

MemNum=1;
A=60;
L=1.5e3;
Qf1 = zeros(NEdof,1);
[k1]=Create_K(E,A,L);
[S,Pf]=Assemble_S_Pf(S,Pf,k1,Qf1,MemNum,NEdof,NSdof,CodeNum);

MemNum=2;
A=75;
L=1.5e3;
Qf2 = zeros(NEdof,1);
[k2]=Create_K(E,A,L);
[S,Pf]=Assemble_S_Pf(S,Pf,k2,Qf2,MemNum,NEdof,NSdof,CodeNum);

MemNum=3;
A=90;
L=0.75e3;
Qf3 = zeros(NEdof,1);
[k3]=Create_K(E,A,L);
[S,Pf]=Assemble_S_Pf(S,Pf,k3,Qf3,MemNum,NEdof,NSdof,CodeNum);

MemNum=4;
A=120;
L=1.0e3;
w=48e-3;
Qf4 = w*L/2*[-1; -1]
[k4]=Create_K(E,A,L);
[S,Pf]=Assemble_S_Pf(S,Pf,k4,Qf4,MemNum,NEdof,NSdof,CodeNum);


%***************** SOLVE *****************
Pf
S

% Solve for displacements (note the use of the backslash operator instead
% of the inv command. We could have used d=inv(S)*(P), or even
% d=S^-1*(P), but the backslash approach is much more efficient.)
d=S\(P-Pf)


%************** POST-PROCESS *************

% Use compatibility to create the {u} vectors for each element
u1=[0; d(1)];
u2=[0; d(1)];
u3=[d(1); d(2)];
u4=[d(2); 0];

% Calculate the member end forces
Q1=Qf1+k1*u1
Q2=Qf2+k2*u2
Q3=Qf3+k3*u3
Q4=Qf4+k4*u4

% Calculate the support reactions
R3=Q1(1)+Q2(1)
R4=Q4(2)        % Index(i) selects corresponding member end force 1,2 

